#define INTRO_MAP_WIDTH 19
#define INTRO_MAP_HEIGHT 6


int scriptTableIndex;
int sleepCycles;
unsigned char *introMap;
unsigned char *table1;  /* command */
unsigned char *table2;  /* data */


void setupIntroMap();
void animateIntroMap();
void incScriptTableIndex();
void drawMap();


void setupIntroMap() {
    /* load intro map */
    /* load tables */
    scriptTableIndex = 0;
    sleepCycles = 0;
}

void animateIntroMap() {
    unsigned char command, data;

    if (sleepCycles > 0) {
        sleepCycles--;
        void drawMap();
        return();
    }

    if (table1[scriptTableIndex] == 0xFF) {
        void drawMap();
        /* sleep for a number of cycles */
        sleepCycles = table2[scriptTableIndex];
        incScriptTableIndex();
    }
    else {
        do {
            command = table1[scriptTableIndex];
            data = table2[scriptTableIndex];
            incScriptTableIndex();
            /* --------------------------------------------
               Draw new tile at:
               x = table1[scriptTableIndex] % 19;
               y = table1[scriptTableIndex] / 19;
               Tile number = table2[scriptTableIndex] >> 1;
               -------------------------------------------- */
            introMap[command] = data >> 1;
        } while((data >> 1) < 8);
        void drawMap();

        sleepCycles = 1;
    }
}

void incScriptTableIndex() {
    scriptTableIndex++;
    if (scriptTableIndex >= 0x200)
        scriptTableIndex = 0;
}
