; ===========================================
; Numlock patch for Ultima 5
; This program patches ultima.exe in memory.
; 
; Last update: 20-March-2004
; Assembled with NASM 0.98.38 (as a COM file)
;
; How to assemble:
; nasmw -fbin -o u5numlck.com u5numlck.asm
; ===========================================

full_seg        equ     65536

                org     100h

section         .text
                ; -------------------------------------------
                ;   initialize stack and free unused memory
                ; -------------------------------------------
                mov     sp,stack_end

                mov     ah,4ah
                mov     bx,stack_end+0fh
                mov     cl,4
                shr     bx,cl
                int     21h

                ; -------------------
                ;   load ultima.exe
                ; -------------------
                mov     word [seg_env],0
                mov     word [cmd_line_ofs],80h
                mov     word [cmd_line_seg],ds
                mov     word [fcb_1_ofs],5ch
                mov     word [fcb_1_seg],ds
                mov     word [fcb_2_ofs],6ch
                mov     word [fcb_2_seg],ds
                ; function 4bh, subfunction 1 (load program)
                mov     ah,4bh
                mov     al,1
                mov     dx,ultima_exe
                mov     bx,seg_env
                int     21h
                jc      error_quit

                ; --------------------
                ;   patch ultima.exe
                ; --------------------
                ; get the program's PSP
                mov     ah,62h
                int     21h
                mov     es,bx
                mov     ds,bx

                ; apply the patch
                mov     byte [1ed0h],03

                ; apply the patch 2
                mov     byte [1e86h+0],9ah               ; far call
                mov     word [1e86h+1],keyb_patch        ; offset
                mov     word [1e86h+3],cs                ; segment
                mov     byte [1e86h+5],90h               ; nop

                mov     byte [1e92h+0],9ah               ; far call
                mov     word [1e92h+1],keyb_patch2       ; offset
                mov     word [1e92h+3],cs                ; segment
                mov     byte [1e92h+5],90h               ; nop

                ; ------------------
                ;   run ultima.exe
                ; ------------------
                ; change the program's termination address
                mov     word [10],ultima_success
                mov     [12],cs

                ; set the program's stack
                mov     ss,[cs:child_ss]
                mov     sp,[cs:child_sp]

                ; run avatar.exe
                jmp     far [cs:child_ip]
ultima_success:
                ; restore segment registers
                mov     ax,cs
                mov     ss,ax
                mov     sp,stack_end
                mov     ds,ax
                mov     es,ax

                ; read the exit code returned by avatar.exe
                mov     ah,4dh
                int     21h
                mov     [exit_code],al
quit:
                mov     ah,4ch
                mov     al,[exit_code]
                int     21h
error_quit:
                mov     ax,cs
                mov     ds,ax
                mov     dx,error_str
                mov     ah,9                
                int     21h
                mov     byte [exit_code],1
                jmp     quit

ultima_exe      db      'ultima.exe', 0

seg_env         dw      0
cmd_line_ofs    dw      0
cmd_line_seg    dw      0
fcb_1_ofs       dw      0
fcb_1_seg       dw      0
fcb_2_ofs       dw      0
fcb_2_seg       dw      0

child_sp        dw      0
child_ss        dw      0
child_ip        dw      0
child_cs        dw      0

error_str       db      'An error has occurred.',0dh,0ah,'$'
exit_code       db      0

scan_code       db      0
ascii_code      db      0

numpad_codes    db      47h, 48h, 49h, 4bh, 4ch, 4dh, 4fh, 50h, 51h
numpad_end:

; ------------------
;   keyboard patch
; ------------------
keyb_patch:
                push    bx
                pushf
                mov     ah,0
                int     16h
                mov     [cs:scan_code],ah
                mov     [cs:ascii_code],al
                ; is the key on the numpad?
                mov     bx,numpad_codes
numpad_loop:
                cmp     [cs:bx],ah
                jz      is_numpad
                inc     bx
                cmp     bx,numpad_end
                jb      numpad_loop
                jmp     not_numpad
is_numpad:
                mov     al,0
not_numpad:
                popf
                pop     bx
                ; clear zero flag
                lahf
                and     ah,0ffh-40h
                sahf
                retf
keyb_patch2:
                mov     al,[cs:scan_code]
                ; clear zero flag
                lahf
                and     ah,0ffh-40h
                sahf
                retf

section         .bss
stack_start     resb    256
stack_end:
